/**
 * 
 */
package com.digitalsanctuary.droplet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import atg.nucleus.ServiceException;
import atg.repository.RepositoryItem;
import atg.repository.xml.GetException;
import atg.repository.xml.GetService;
import atg.servlet.DynamoHttpServletRequest;
import atg.servlet.DynamoHttpServletResponse;
import atg.servlet.DynamoServlet;

/**
 * @author Devon Hillard
 * 
 */
public class ItemToXMLDroplet extends DynamoServlet {

    private GetService mGetService;

    /*
     * (non-Javadoc)
     * 
     * @see atg.nucleus.GenericService#doStartService()
     */
    public void doStartService() throws ServiceException {
	super.doStartService();
	if (getGetService() == null) {
	    throw new ServiceException("GetService was not configured properly.");
	}
    }

    public void service(DynamoHttpServletRequest pRequest, DynamoHttpServletResponse pResponse)
	    throws ServletException, IOException {
	RepositoryItem item = (RepositoryItem) pRequest.getLocalParameter("item");
	String xml = null;
	if (item != null) {
	    try {
		xml = getGetService().getItemAsXML(item);
	    } catch (GetException e) {
		if (isLoggingError()) {
		    logError("ItemToXMLDroplet.service: ", e);
		}
	    }
	}
	ServletOutputStream out = pResponse.getOutputStream();
	out.println(xml);
    }

    /**
     * @return the getService
     */
    public GetService getGetService() {
	return this.mGetService;
    }

    /**
     * @param pGetService
     *                the getService to set
     */
    public void setGetService(GetService pGetService) {
	this.mGetService = pGetService;
    }

}
